VTK: vtkOpenXRManagerGraphics Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkOpenXRManagerGraphics Class Referenceabstract

OpenXR manager graphics implementation. More...

`#include <vtkOpenXRManagerGraphics.h>`

Inheritance diagram for vtkOpenXRManagerGraphics:
[legend]
Collaboration diagram for vtkOpenXRManagerGraphics:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkOpenXRManagerGraphics * | NewInstance () const
virtual void | SetNumberOfSwapchains (uint32_t viewCount)=0
| Resize the internal vectors storing the color and depth swapchains. More...
uint32_t | GetChainLength (XrSwapchain swapchain)
| Acquire the number of images in the specified swapchain. More...
virtual bool | CreateGraphicsBinding (vtkOpenGLRenderWindow *helperWindow)=0
| Create the graphics binding and store it in GraphicsBindings ptr. More...
virtual const void * | GetGraphicsBinding ()=0
| Return pointer to the backend-specific XrGraphicsBindingXXX structure that is required to create the OpenXR session. More...
virtual bool | CheckGraphicsRequirements (XrInstance instance, XrSystemId id)=0
| OpenXR requires checking graphics requirements before creating a session. More...
virtual const char * | GetBackendExtensionName ()=0
| Return the extension name to enable a specific rendering backend. More...
virtual void | GetColorSwapchainImage (uint32_t eyeIndex, uint32_t imgIndex, void *texture)=0
| Fill `texture` with the swapchain image for the specified eye. More...
virtual void | GetDepthSwapchainImage (uint32_t eyeIndex, uint32_t imgIndex, void *texture)=0
| Fill `texture` with the swapchain image for the specified eye. More...
virtual void | EnumerateColorSwapchainImages (XrSwapchain swapchain, uint32_t eyeIndex)=0
| Acquire swapchain images using xrEnumerateSwapchainImages and store them at the specified eye index. More...
virtual void | EnumerateDepthSwapchainImages (XrSwapchain swapchain, uint32_t eyeIndex)=0
| Acquire swapchain images using xrEnumerateSwapchainImages and store them at the specified eye index. More...
virtual const std::vector< int64_t > & | GetSupportedColorFormats ()=0
| Return the list of pixel formats supported by VTK. More...
virtual const std::vector< int64_t > & | GetSupportedDepthFormats ()=0
| Return the list of pixel formats supported by VTK. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkOpenXRManagerGraphics * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkOpenXRManagerGraphics ()=default
| ~vtkOpenXRManagerGraphics () override=default
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

OpenXR manager graphics implementation.

Abstract class that defines the rendering backend used by vtkOpenXRManager. It handles creation and management of the OpenXR rendering resources, based on the rendering backend implemented by subclasses.

See also
  vtkOpenXRManagerOpenGLGraphics vtkOpenXRManagerD3DGraphics

Definition at line 28 of file vtkOpenXRManagerGraphics.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkOpenXRManagerGraphics::Superclass

Definition at line 31 of file vtkOpenXRManagerGraphics.h.

## Constructor & Destructor Documentation

## ◆ vtkOpenXRManagerGraphics()

vtkOpenXRManagerGraphics::vtkOpenXRManagerGraphics | ( |  | ) |
| protecteddefault

## ◆ ~vtkOpenXRManagerGraphics()

vtkOpenXRManagerGraphics::~vtkOpenXRManagerGraphics | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkOpenXRManagerGraphics::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkOpenXRManagerGraphics::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ SafeDownCast()

static vtkOpenXRManagerGraphics* vtkOpenXRManagerGraphics::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkOpenXRManagerGraphics::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ NewInstance()

vtkOpenXRManagerGraphics* vtkOpenXRManagerGraphics::NewInstance | ( |  | ) | const

## ◆ SetNumberOfSwapchains()

virtual void vtkOpenXRManagerGraphics::SetNumberOfSwapchains | ( | uint32_t | viewCount | ) |
| pure virtual

Resize the internal vectors storing the color and depth swapchains.

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ GetColorSwapchainImage()

virtual void vtkOpenXRManagerGraphics::GetColorSwapchainImage | ( | uint32_t | eyeIndex,
|  | uint32_t | imgIndex,
|  | void * | texture
| ) |  |
| pure virtual

Fill `texture` with the swapchain image for the specified eye.

The image index should be obtained beforehand using xrAcquireSwapchainImage.

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ GetDepthSwapchainImage()

virtual void vtkOpenXRManagerGraphics::GetDepthSwapchainImage | ( | uint32_t | eyeIndex,
|  | uint32_t | imgIndex,
|  | void * | texture
| ) |  |
| pure virtual

Fill `texture` with the swapchain image for the specified eye.

The image index should be obtained beforehand using xrAcquireSwapchainImage.

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ EnumerateColorSwapchainImages()

virtual void vtkOpenXRManagerGraphics::EnumerateColorSwapchainImages | ( | XrSwapchain | swapchain,
|  | uint32_t | eyeIndex
| ) |  |
| pure virtual

Acquire swapchain images using xrEnumerateSwapchainImages and store them at the specified eye index.

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ EnumerateDepthSwapchainImages()

virtual void vtkOpenXRManagerGraphics::EnumerateDepthSwapchainImages | ( | XrSwapchain | swapchain,
|  | uint32_t | eyeIndex
| ) |  |
| pure virtual

Acquire swapchain images using xrEnumerateSwapchainImages and store them at the specified eye index.

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ GetChainLength()

uint32_t vtkOpenXRManagerGraphics::GetChainLength | ( | XrSwapchain | swapchain | ) |

Acquire the number of images in the specified swapchain.

## ◆ GetSupportedColorFormats()

virtual const std::vector<int64_t>& vtkOpenXRManagerGraphics::GetSupportedColorFormats | ( |  | ) |
| pure virtual

Return the list of pixel formats supported by VTK.

The first pixel format in the list that is also supported by the runtime will be picked for rendering.

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ GetSupportedDepthFormats()

virtual const std::vector<int64_t>& vtkOpenXRManagerGraphics::GetSupportedDepthFormats | ( |  | ) |
| pure virtual

Return the list of pixel formats supported by VTK.

The first pixel format in the list that is also supported by the runtime will be picked for rendering.

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ CreateGraphicsBinding()

virtual bool vtkOpenXRManagerGraphics::CreateGraphicsBinding | ( | vtkOpenGLRenderWindow * | helperWindow | ) |
| pure virtual

Create the graphics binding and store it in GraphicsBindings ptr.

It points to a XrGraphicsBindingXXX structure, depending on the desired rendering backend.

Precondition
  `helperWindow` must be initialized

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ GetGraphicsBinding()

virtual const void* vtkOpenXRManagerGraphics::GetGraphicsBinding | ( |  | ) |
| pure virtual

Return pointer to the backend-specific XrGraphicsBindingXXX structure that is required to create the OpenXR session.

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ CheckGraphicsRequirements()

virtual bool vtkOpenXRManagerGraphics::CheckGraphicsRequirements | ( | XrInstance | instance,
|  | XrSystemId | id
| ) |  |
| pure virtual

OpenXR requires checking graphics requirements before creating a session.

This uses a function pointer loaded with the selected graphics API extension. /pre The XR instance and system id must be initialized

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

## ◆ GetBackendExtensionName()

virtual const char* vtkOpenXRManagerGraphics::GetBackendExtensionName | ( |  | ) |
| pure virtual

Return the extension name to enable a specific rendering backend.

Implemented in vtkOpenXRManagerD3DGraphics, and vtkOpenXRManagerOpenGLGraphics.

The documentation for this class was generated from the following file:

- Rendering/OpenXR/vtkOpenXRManagerGraphics.h